package com.iconplus.smartproc.model.entity;

import com.iconplus.smartproc.helper.base.BaseEntity;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Type;

import javax.persistence.*;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name = "permission")
public class Permission extends BaseEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @Column(name = "role_id")
    private Long roleId;

    @Column(name = "menu_id")
    private Long menuId;

    @Column(name = "can_view")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean canView;

    @Column(name = "can_create")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean canCreate;

    @Column(name = "can_read")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean canRead;

    @Column(name = "can_update")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean canUpdate;

    @Column(name = "can_delete")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean canDelete;

    @Column(name = "is_delete")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isDelete;
}
