package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.entity.MetodePengadaan;
import com.iconplus.smartproc.model.projection.MetodePengadaanView;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Optional;

@Repository
public interface MetodePengadaanRepository extends JpaRepository<MetodePengadaan, Long> {

    @Query(value = "SELECT mp.id as id, " +
            "mp.metodePengadaan as metodePengadaan, " +
            "mp.keterangan as keterangan, " +
            "mp.isActive as isActive, " +
            "mp.isDelete as isDelete " +
            "FROM MetodePengadaan mp " +
            "WHERE mp.isDelete = false " +
            "AND (:search = '' " +
            "or UPPER(mp.metodePengadaan) like :search) " +
            "ORDER BY mp.id")
    Page<MetodePengadaanView> getAllMetodePengadaan(String search, Pageable pageable);

    Optional<MetodePengadaan> findByIdAndIsDeleteFalse(Long id);

    Optional<MetodePengadaan> findByMetodePengadaanAndIsDeleteFalse(String metodePengadaan);
    
}
