package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.entity.StrategiPengadaan;
import com.iconplus.smartproc.model.projection.StrategiPengadaanView;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Optional;

@Repository
public interface StrategiPengadaanRepository extends JpaRepository<StrategiPengadaan, Long> {

    @Query(value = "SELECT sp.id as id, " +
            "sp.strategiPengadaan as strategiPengadaan, " +
            "sp.keterangan as keterangan, " +
            "sp.isActive as isActive, " +
            "sp.isDelete as isDelete " +
            "FROM StrategiPengadaan sp " +
            "WHERE sp.isDelete = false " +
            "AND (:search = '' " +
            "or UPPER(sp.strategiPengadaan) like :search) " +
            "ORDER BY sp.id")
    Page<StrategiPengadaanView> getAllStrategiPengadaan(String search, Pageable pageable);

    Optional<StrategiPengadaan> findByIdAndIsDeleteFalse(Long id);

    Optional<StrategiPengadaan> findByStrategiPengadaanAndIsDeleteFalse(String strategiPengadaan);
    
}
