package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.projection.UnitInisiatorView;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import com.iconplus.smartproc.model.entity.UnitInisiator;

import java.util.Optional;

@Repository
public interface UnitInisiatorRepository extends JpaRepository<UnitInisiator, Long> {

    Optional<UnitInisiator> findByIdAndIsDeleteFalse(Long id);
    Optional<UnitInisiator> findByUnitInisiatorAndIsDeleteFalse(String unitInisiator);

    @Query(value = "SELECT ui.id as id, " +
            "ui.unitInisiator as unitInisiator, " +
            "ui.keterangan as keterangan, " +
            "ui.isActive as isActive " +
            "FROM UnitInisiator ui " +
            "WHERE ui.isDelete = false " +
            "AND (:search = '' OR UPPER(ui.unitInisiator) like :search) " +
            "ORDER BY ui.id")
    Page<UnitInisiatorView> getListUnitInisiator(String search, Pageable pageable);


}
