package com.iconplus.smartproc.service.bidang;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.BidangRequest;
import com.iconplus.smartproc.model.response.BidangResponse;
import com.iconplus.smartproc.repository.BidangRepository;
import org.springframework.stereotype.Service;

@Service
public class GetBidangService implements BaseService<BidangRequest, BidangResponse> {

    private BidangRepository bidangRepository;

    public GetBidangService(BidangRepository bidangRepository) {
        this.bidangRepository = bidangRepository;
    }

    @Override
    public BidangResponse execute(BidangRequest input) {

        var bidang = bidangRepository.findByIdAndIsDeleteFalse(input.getId()).orElseThrow(() -> new BusinessException("err", "err", "err"));
        return BidangResponse.builder()
                .id(bidang.getId())
                .instansiId(bidang.getInstansiId())
                .bidang(bidang.getBidang())
                .keterangan(bidang.getKeterangan())
                .isActive(bidang.getIsActive())
                .build();
    }
}
