package com.iconplus.smartproc.service.instansi;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.InstansiRequest;
import com.iconplus.smartproc.repository.InstansiRepository;
import org.springframework.stereotype.Service;

@Service
public class DeleteInstansiService implements BaseService<InstansiRequest, EmptyResponse> {

    private InstansiRepository instansiRepository;

    public DeleteInstansiService(InstansiRepository instansiRepository) {
        this.instansiRepository = instansiRepository;
    }

    @Override
    public EmptyResponse execute(InstansiRequest input) {

        var instansi = instansiRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException("err", "err", "err"));

        instansi.setIsDelete(true);
        instansiRepository.save(instansi);

        return new EmptyResponse();
    }
}
