package com.iconplus.smartproc.service.jabatan;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.JabatanRequest;
import com.iconplus.smartproc.model.response.JabatanResponse;
import com.iconplus.smartproc.repository.JabatanRepository;
import org.springframework.stereotype.Service;

@Service
public class PutUpdateJabatanService implements BaseService<JabatanRequest, JabatanResponse> {

    private JabatanRepository jabatanRepository;
    public PutUpdateJabatanService(JabatanRepository jabatanRepository) {
        this.jabatanRepository = jabatanRepository;
    }

    @Override
    public JabatanResponse execute(JabatanRequest input) {

        var jabatan = jabatanRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException("err", "err", "err"));

        jabatan.setJabatan(input.getJabatan());
        jabatan.setKeterangan(input.getKeterangan());
        jabatan.setInstansiId(input.getInstansiId());
        jabatan.setBidangId(input.getBidangId());
        jabatan.setIsActive(input.getIsActive());
        var result = jabatanRepository.save(jabatan);
        return JabatanResponse.builder()
                .id(result.getId())
                .build();
    }
}
