package com.iconplus.smartproc.service.jeniskontrak;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.JenisKontrakRequest;
import com.iconplus.smartproc.repository.JenisKontrakRepository;
import com.iconplus.smartproc.util.Constants;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class DeleteJenisKontrakService implements BaseService<JenisKontrakRequest, EmptyResponse> {

    private JenisKontrakRepository jenisKontrakRepository;

    public DeleteJenisKontrakService(JenisKontrakRepository jenisKontrakRepository) {
        this.jenisKontrakRepository = jenisKontrakRepository;
    }


    @Override
    public EmptyResponse execute(JenisKontrakRequest input) {

        var jenisKontrak = jenisKontrakRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(HttpStatus.CONFLICT,
                        Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, input.getId())));

        jenisKontrak.setIsDelete(true);
        jenisKontrakRepository.save(jenisKontrak);
        log.info("success delete jenis kontrak id {}", jenisKontrak.getIsDelete());
        return new EmptyResponse();
    }
}
