package com.iconplus.smartproc.service.metodepengadaan;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.MetodePengadaanRequest;
import com.iconplus.smartproc.repository.MetodePengadaanRepository;
import com.iconplus.smartproc.util.Constants;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class DeleteMetodePengadaanService implements BaseService<MetodePengadaanRequest, EmptyResponse> {

    private MetodePengadaanRepository metodePengadaanRepository;

    public DeleteMetodePengadaanService(MetodePengadaanRepository metodePengadaanRepository) {
        this.metodePengadaanRepository = metodePengadaanRepository;
    }


    @Override
    public EmptyResponse execute(MetodePengadaanRequest input) {

        var metodePengadaan = metodePengadaanRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(HttpStatus.CONFLICT,
                        Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, input.getId())));

        metodePengadaan.setIsDelete(true);
        metodePengadaanRepository.save(metodePengadaan);
        log.info("success delete metode pengadaan id {}", metodePengadaan.getIsDelete());
        return new EmptyResponse();
    }
}
